%Eric Winchell
%Question 2d, Modeling Assignment #1
%January 29, 2013

clear
clc

alpha=4; %initial angle of basin
E=2.5; %evaporation rate (m/yr)
P=.1; %precipitation rate (m/yr)
I=0.5; %infiltration coefficient
dt=.01; %time step (yr)
Ab=1000^3; %basin volume
t=2:2000; %time range (yrs)
v=[]; %set up null matrix to catalogue volumes
v(1)=0; %initial volume is 0
h=[]; %set up null matrix to catalogue lake height
h(1)=0; %initial height is 0
r=[]; %set up null matrix to catalogue lake radius
r(1)=0; %initial radius is 0
A=[]; %set up null matrix to catalogue lake area
A(1)=0; %initial area is 0

for i=2:length(t)
    dv=((pi*(h(i-1)*tan((90-alpha)*(pi/180)))^2)*(-E+(I*P))+Ab*(P-(I*P)))*dt; %equation to calculate change in lake volume
    volume=v(i-1)+dv; %old lake volume plus calculated change in lake volume
    v=[v;volume]; %updating volume matrix
    hnew=((3*volume)/(pi*tan((90-alpha)*(pi/180)))).^(1/3); %equation to calculate new lake height as a function of new volume
    h=[h;hnew]; %updating height matrix
    rnew=hnew*tan((90-alpha)*(pi/180)); %equation calculating new lake radius as a function of new height
    r=[r;rnew]; %updating lake radius matrix
    Anew=pi*rnew^2; %equation calculating new lake area as a function of new radius
    A=[A,Anew]; %updating lake area matrix
end

%characteristic values
char=1-(1/exp(1));
char_v=char*v(1999);
char_A=char*A(1999);
char_h=char*h(1999);
%corresponding characteristic times
tchar_v=t(min(find(v>char_v)));
tchar_A=t(min(find(A>char_A)));
tchar_h=t(min(find(h>char_h)));

%plotting
figure
subplot(3,1,1), plot(t,v)
hold on
plot(tchar_v,char_v,'ro');
legend('history of lake volume','characteristic time')
title('Lake Volume, Height, and Area as a Function of Time','FontSize',12)
xlabel('time (yrs)');
ylabel('volume (m^3)');
subplot(3,1,2), plot(t,h)
hold on
plot(tchar_h,char_h,'ro');
legend('history of lake height','characteristic time')
xlabel('time (yrs)');
ylabel('lake height (m)');
subplot(3,1,3), plot(t,A)
hold on
plot(tchar_A,char_A,'ro');
legend('history of lake area','characteristic time')
xlabel('time (yrs)');
ylabel('lake area (m^2)');

